#include "dma.h"
#include "io.h"
#include "interrupt.h"

/***************************************
* ʵ                             *
***************************************/

void dma_open_dma_channel( unsigned char dma_channel , void* start_address_in_memory , unsigned short count , enum dma_read_or_write_model_enum read_or_write_model )
{
  /* ȡͨӦҳĴ˿ں */
  int page_port ;

  switch( dma_channel ){
    case 2 :
      page_port = 0x81 ;
      break ;
  } ;

  // ж
  interrupt_close_interrupt() ;

  // ȹر dma ͨ
  dma_close_dma_channel( dma_channel ) ;

  if( dma_channel <= 3 ){ // ʹõǵһDMA
    // ֽڼ
    io_write_to_io_port( 0xc , 0 ) ;

    // ģʽλ
    union {
      unsigned char ch ;
      struct{
        unsigned char channel : 2 ;
        unsigned char transfer_type : 2 ;
        unsigned char auto_intialization_enable : 1 ;
        unsigned char address_increment_or_decrement : 1 ;
        unsigned char model : 2 ;        
      } ;
    } s ;
    s.model = 1 ; 
    s.address_increment_or_decrement = 0 ;
    s.auto_intialization_enable = 0 ;
    s.transfer_type = read_or_write_model ;
    s.channel = dma_channel ;
    io_write_to_io_port( 0xb , s.ch ) ;

    
    // ַƫ
    unsigned int offset = ( unsigned int )start_address_in_memory ;
    io_write_to_io_port( dma_channel * 2 , offset ) ;      // ƫĵ8λ
    io_write_to_io_port( dma_channel * 2 , offset >> 8 ) ; // ƫĸ8λ

    // ҳ(ַĶεַ)
    io_write_to_io_port( page_port , offset >> 16 ) ;

    // ʹ
    io_write_to_io_port( dma_channel * 2 + 1 , ( count - 1 ) ) ;      // ʹĵ8λ
    io_write_to_io_port( dma_channel * 2 + 1 , ( count - 1 ) >> 8 ) ; // ʹĸ8λ 

    //  dma ͨ
    switch( dma_channel ){
      case 2 :
        io_write_to_io_port( 0xa , 0x2 ) ;
        break ;
    } ;
  }

  // ж
  interrupt_open_interrupt() ;
}

/* ر dma ͨ */
void dma_close_dma_channel( unsigned char dma_channel )
{
  switch( dma_channel ){
    case 2 :
      io_write_to_io_port( 0xa , 0x6 ) ;
      break ;
  } ;
}
