#include "interrupt.h"
#include "io.h"
#include "message.h"
#include "kernel.h"

/*****************************************************
*                                          *
*****************************************************/

void keyboard_asm_handle_for_keyboard_interrupt() ;

void keyboard_handle_for_keyboard_interrupt() ;


/*****************************************************
* Ƕ                                         *
*****************************************************/

static const int KEYBOARD_KEYBOARD_INTERRUPT_NUMBER = 0x21 ;
static const int KEYBOARD_KEYBOARD_INTERRUPT_IRQ_NUMBER = 1 ;

static int keyboard_is_extention_key_scan_code ;
/*****************************************************
* Ǻʵ                                   *
*****************************************************/

void keyboard_init()
{
  keyboard_is_extention_key_scan_code = 0 ;

  // װжϴ
  interrupt_install_handle_for_interrupt( KEYBOARD_KEYBOARD_INTERRUPT_NUMBER , keyboard_asm_handle_for_keyboard_interrupt ) ;

  // ж
  interrupt_set_interrupt_mask_word( KEYBOARD_KEYBOARD_INTERRUPT_IRQ_NUMBER , 1 ) ;
}

// жϴ
void keyboard_handle_for_keyboard_interrupt()
{
  unsigned char ch = io_read_from_io_port( 0x60 ) ;

  // ȹ˵ֽڣչ룬
  if( ch == 0x0 || ch > 0x80){ // 0x0 ʾ > 0x80 ʾ 0xe0 չ
    return ; 
  }
  else{ 
    // ϢһϢ͸ں
    switch( ch ){
      case 0x1 :
        ch = 'r' ; //  ESC  R ʾ
        break ;
      case 0x17 :
        ch = 'i' ;
        break ;
      case 0x24 :
        ch = 'j' ;
        break ;
      case 0x25 :
        ch = 'k' ;
        break ;
      case 0x26 :
        ch = 'l' ;
        break ;
      default :
        ch = 0 ;
    }
    if( ch ){
      struct message_message_struct message ;
      message.message_type = MESSAGE_KEYBOARD_MESSAGE ;
      message.key = ch ;
      message_put_message( &kernel_message_queue , message ) ;
    }
  }
}
