#include "interrupt.h"
#include "mouse.h"
#include "keyboard.h"
#include "floppy.h"
#include "fat12.h"
#include "io.h"
#include "vesa.h"

/**************************************************
* ǱļõĶ                  *
* ͷļ,ΪļҪʹ     *
**************************************************/

/* GDTṹ */
struct system_gdt_item_struct{  
  unsigned short seg_length_limit_0_15 ;       // 0~15λ
  unsigned short seg_base_addr_0_15 ;          // ַ 0~15λ
  unsigned char  seg_base_addr_16_23 ;         // ַ16~23λ
  unsigned char  type    : 4 ;                   // typeλ
  unsigned char  s       : 1 ;                   // Sλ
  unsigned char  dpl     : 2 ;                   // Ȩλ
  unsigned char  p       : 1 ;                   // Pλ
  unsigned char  seg_length_limit_16_19 : 4 ;  // ޵16~19λ
  unsigned char  avl     : 1 ;                   // AVLλ
  unsigned char  saved_0 : 1 ;                   // λΪ0
  unsigned char  d_or_b  : 1 ;                   // D/Bλ
  unsigned char  g       : 1 ;                   // Gλ
  unsigned char  seg_base_addr_24_31 ;          // ַ24~31λ
} ;

/* GDTṹ */
struct system_gdt_struct{ 
  struct system_gdt_item_struct null_seg ;        // նΣIntel
  struct system_gdt_item_struct system_code_seg ; // ϵͳ
  struct system_gdt_item_struct system_date_seg ; // ϵͳݶ  
} ;

/* GDT ṹ */
struct system_gdt_descriptor_struct{ 
  unsigned short gdt_length_limit ;
  struct system_gdt_struct *gdt_addr ;
} ;

/* gdt ʼ */
static void system_init_gdt() ;
static void system_load_resource() ;

/*******************************************************************
* Ǹ                                                   *
*******************************************************************/

/*  gdt  */
static struct system_gdt_struct system_gdt ;

/*  gdt  */
static struct system_gdt_descriptor_struct system_gdt_descriptor ;

/*******************************************************************
* Ǻʵ                                                 *
*******************************************************************/

/* Դ뺯 */
void system_load_resource()
{
  /*******************************************************
  * ̶ڴ,ڴ˵
  * 0x100000 : fat12 λ
  * 0x110000 : login_1.bmp λ
  * 0x120000 : login_2.bmp λ
  * 0x130000 : mouse ͼƬ
  * 0x140000 : Ӣֿ
  * 0x141000 : ֿ
  * 0x190000 : ӦóͼƬ
  * 0x199000 : 
  * 0x19c000 : picfileͼƬ
  * 0x1a0000 : normalfileͼƬ
  * 0x1a3000 : floppyͼƬ
  * 0x1a5000 : upͼƬ
  * 0x1a6000 : downͼƬ
  * 0x1a7000 : leftͼƬ
  * 0x1a8000 : rightͼƬ
  * 0x1a9000 : txtfileļ
  * 0x1ab100 : closeļ
  * 0x1b0000 : logout.bmp
  * 0x1c0000 : waiting.bmp
  ********************************************************/

  //  waiting.bmp
  fat12_load_file( "waiting.bmp" , ( void * )0x1c0000 ) ;
  // ʾ waiting
  // ðɫ
  unsigned short color = vesa_compond_rgb( 255 , 255 , 255 ) ;
  vesa_clean_screen( color ) ;  

  // ʾ˳ͼƬ( 246 * 103 )
  vesa_show_bmp_picture( 277 , 248 , ( void * )0x1c0000 , 0 , 0 ) ;

  // һͼ
  fat12_load_file( "login_1.bmp" , ( void * )0x110000 ) ; 

  // ڶͼ
  fat12_load_file( "login_2.bmp" , ( void * )0x120000 ) ;

  //  mouse ͼƬ
  fat12_load_file( "mouse_1.bmp" , ( void * )0x130000 ) ;
  fat12_load_file( "mouse_2.bmp" , ( void * )0x131000 ) ;
  fat12_load_file( "mouse_3.bmp" , ( void * )0x132000 ) ;

  // ֿ
  fat12_load_file( "asc16.fnt" , ( void * )0x140000 ) ;
  fat12_load_file( "hzk16.fnt" , ( void * )0x141000 ) ;

  // ӦóͼƬ
  fat12_load_file( "mycmp.bmp" , ( void * )0x190000 ) ;
  
  // 붥
  fat12_load_file( "top.bmp" , ( void * )0x199000 ) ;

  // ļͼƬ
  fat12_load_file( "picfile.bmp" , ( void * )0x19c000 ) ;
  fat12_load_file( "normal.bmp" , ( void * )0x1a0000 ) ;

  //  floppy , up , down ͼƬ
  fat12_load_file( "floppy.bmp" , ( void * )0x1a3000 ) ;
  fat12_load_file( "up.bmp" , ( void * )0x1a5000 ) ;
  fat12_load_file( "down.bmp" , ( void * )0x1a6000 ) ;
  fat12_load_file( "left.bmp" , ( void * )0x1a7000 ) ;
  fat12_load_file( "right.bmp" , ( void * )0x1a8000 ) ;

  //  txtfile ͼƬ
  fat12_load_file( "txtfile.bmp" , ( void * )0x1a9000 ) ;

  //  close ͼƬ
  fat12_load_file( "close.bmp" , ( void * )0x1ab100 ) ;

  //  logout ͼƬ
  fat12_load_file( "logout.bmp" , ( void * )0x1b0000 ) ;
}

/* ϵͳʼ */
void system_init()  
{
  // Ժ gdt Ŀ,,˴Ӧ³ʼ gdt ,Ա gdt λ
  system_init_gdt() ;
  
  // ʼж
  interrupt_init() ; //0x900a7
  
  // ĲҪжϸ,ȿж
  // ж
  interrupt_open_interrupt() ;  
  
  // ʼ floppy
  floppy_init( ( void * )0x30000 ) ;//0x900b4

  // ʼ fat12 ļϵͳ
  fat12_init( ( void * )0x100000 ) ; //0x900c9

  // ϵͳԴ
  system_load_resource() ;

  // ж
  interrupt_close_interrupt() ;

  // ʼ
  keyboard_init() ;

  // ʼ mouse
  mouse_init() ;

  // ռ̻
  io_read_from_io_port( 0x60 ) ;

  // ж
  interrupt_open_interrupt() ;
}

/* ʼ gdt  */
static void system_init_gdt()
{  
  // ʼϵͳ
  struct system_gdt_item_struct *p = &system_gdt.system_code_seg ;
  p->avl = 0 ;
  p->d_or_b = 1 ;
  p->dpl = 0 ;
  p->g = 1 ;
  p->p = 1 ;
  p->s = 1 ;
  p->saved_0 = 0 ;
  p->seg_base_addr_0_15 = 0 ;
  p->seg_base_addr_16_23 = 0 ;
  p->seg_base_addr_24_31 = 0 ;
  p->seg_length_limit_0_15 = 0xffff ;
  p->seg_length_limit_16_19 = 0xff ;
  p->type = 0x9a ;
 
  // ʼϵͳݶ
  system_gdt.system_date_seg = system_gdt.system_code_seg ;
  system_gdt.system_date_seg.type = 0x92 ;

  // ʼ gdt 
  system_gdt_descriptor.gdt_addr = &system_gdt ;
  system_gdt_descriptor.gdt_length_limit = 0xffff ;

  // Ƕ gdt 
  __asm__( "lgdt %0" : "=m"( system_gdt_descriptor ) ) ; //GDT

  // Ķ setup.asm еĶ gdt һڴ˴ӦμĴ
  // Ը¸μĴӰ
}

